## openj9-19 0.37.0

=== debian/changelog ===
openj9-19 (0.37.0-1) unstable; urgency=medium

  * Rebuild with new package names

 -- Mathieu Baudier <mbaudier@argeo.org>  Wed, 05 Nov 2025 17:53:49 +0000
